; 'Acid boil' project :

; Misc service routines.
; Written by EXeLENZ (55:55/2@generalnet, 2:5030/448.1@fidonet).

;******************************* Clear Screen **********************************
;  INPUT : none.
;  OUTPUT: none.
;*******************************************************************************
   _clear_screen PROC NEAR             ;
      push ds cx ax                    ;
      mov cx,64000                     ;
      mov ax,0a000h                    ; set ds to v/mem
      mov ds,ax                        ;
      mov al,0                         ;
fill_cont:                             ;
      mov di,cx                        ; fill 64000 bytes from
      mov [di],al                      ; A000:0000 to A000:FA00
      loop fill_cont                   ; with zeroes
      pop ax cx ds                     ;
      ret                              ;
   _clear_screen ENDP                  ;

;******************** Exit if key pressed or mouse moved ***********************
;  INPUT : none.
;  OUTPUT: set exit flag
;*******************************************************************************
   _exit_if_action PROC NEAR
      pusha                            ;
      mov ah,1                         ; if key pressed
      int 16h                          ;
      jz no_key                        ;
      mov byte ptr [exit_y_n],YES      ; set EXIT flag
      mov ah,0                         ; get key here
      int 16h                          ;
no_key:                                ;
      cmp [mouse_presence],0           ; if no mouse drv installed
      je no_mouse_move                 ;

      mov ax,3                         ; if mouse button pressed
      int 33h                          ; or mouse moved
      add cx,dx                        ;
      add cx,bx                        ;
      cmp cx, word ptr [mouse_state]   ;
      je no_mouse_move                 ;
      mov byte ptr [exit_y_n],YES      ; set EXIT flag
no_mouse_move:                         ;
      popa                             ;
      ret                              ;
   _exit_if_action ENDP

;            (USED WHILE DEBUGGING, NOW REMOVED TO SAVE SPACE)
;******************************* WAIT FOR A KEY*********************************
;  INPUT : none.
;  OUTPUT: none.
;*******************************************************************************
;  wait_for_key PROC NEAR              ; Int 16h, function 00 waits for
;     pusha                            ; a key pressed (if none in buffer).
;     mov ah,0                         ;
;     int 16h                          ;
;     popa                             ;
;     ret                              ;
;  wait_for_key ENDP                   ;

;************************* Force palette look good *****************************
;  INPUT : none.
;  OUTPUT: none.
;*******************************************************************************
   make_normalized_acid_pal PROC NEAR
         xor cl,cl                       ; r(i) = i/4
         mov dx,3c8h                     ; g(i) = 0
         xor al,al                       ; b(i) = (i+2)/4
         out dx,al                       ; i : [0-255]
         inc dx                          ; (mov dx,3c9h)
         mov bl,2
set:
         mov al,cl
         div bl
         out dx,al

         mov al,0
         out dx,al

         mov al,cl
         cmp al,254
         jae need_not_add
         add al,2
need_not_add:
         div bl
         out dx,al

         inc cl
         cmp cl,128
         jb set

         ret
   make_normalized_acid_pal ENDP